%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%{!?_pkgdocdir: %global _pkgdocdir %{_docdir}/%{name}-%{version}}

%global do_tests 0

# The master and slave packages have (in theory) an independent versioning
%global slaveversion %{version}

Name:           buildbot
Version:        0.9.0b1
Release:        1%{?dist}

Summary:        Build/test automation system
Group:          Development/Tools
License:        GPLv2
URL:            http://buildbot.net
Source0:        https://github.com/buildbot/buildbot/archive/v%{version}.tar.gz
Patch0:         buildbot-0.8.10-TypeError.patch

BuildArch:      noarch

BuildRequires:  python-devel
BuildRequires:  python-sphinx
# Needed for tests
%if %do_tests
BuildRequires:  python-sqlalchemy
BuildRequires:  python-migrate
BuildRequires:  python-mock
BuildRequires:  python-dateutil
BuildRequires:  python-twisted-core
BuildRequires:  python-twisted-web
#BuildRequires:  python-twisted-mail
BuildRequires:  python-twisted-words

BuildRequires:  bzr 
BuildRequires:  cvs
BuildRequires:  git
BuildRequires:  mercurial
BuildRequires:  subversion

# darcs available on these archs only
%ifarch %{ix86} x86_64 ppc alpha
BuildRequires:  darcs
%endif
%endif

# Turns former package into a metapackage for installing everything
Requires:       %{name}-master = %{version}
Requires:       %{name}-doc = %{version}
Requires:       %{name}-slave = %{version}


%description
The BuildBot is a system to automate the compile/test cycle required by
most software projects to validate code changes. By automatically
rebuilding and testing the tree each time something has changed, build
problems are pinpointed quickly, before other developers are
inconvenienced by the failure.


%package master
Summary:        Build/test automation system
Group:          Development/Tools
License:        GPLv2

Requires:       python-twisted-core
Requires:       python-twisted-web
Requires:       python-twisted-mail
Requires:       python-twisted-words
Requires:       python-twisted-conch
Requires:       python-boto
Requires:       python-jinja2
Requires:       python-sqlalchemy
Requires:       python-migrate
Requires:       python-dateutil

Requires(post): info
Requires(preun): info


%description master
The BuildBot is a system to automate the compile/test cycle required by
most software projects to validate code changes. By automatically
rebuilding and testing the tree each time something has changed, build
problems are pinpointed quickly, before other developers are
inconvenienced by the failure.

This package contains only the buildmaster implementation.
The buildbot-slave package contains the buildslave.


%package slave
Version:        %{slaveversion}   
Summary:        Build/test automation system
Group:          Development/Tools
License:        GPLv2

Requires:       python-twisted-core


%description slave
This package contains only the buildslave implementation.
The buildbot-master package contains the buildmaster.


%package doc
Summary:    Buildbot documentation
Group:      Documentation

%description doc
Buildbot documentation


%prep
%setup -q
#%patch0 -p2


%build
pushd master
%{__python} setup.py build
popd
pushd slave
%{__python} setup.py build
popd

#make docs

%if %do_tests
%check
trial buildbot.test
%endif


%install
# build master
pushd master
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
popd
# build  slave
pushd slave
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
popd
mkdir -p %{buildroot}%{_datadir}/%{name}/ \
         %{buildroot}%{_mandir}/man1/ \
         %{buildroot}%{_pkgdocdir}

sed -i -e '/#!\/usr\/local/d' master/contrib/bk_buildbot.py
cp -R master/contrib %{buildroot}/%{_datadir}/%{name}/

# install the man page
cp master/docs/buildbot.1 %{buildroot}%{_mandir}/man1/buildbot.1

# install HTML documentation
#tar xf docs/docs.tgz --strip-components=1 -C %{buildroot}%{_pkgdocdir}

# clean up Windows contribs.
#sed -i 's/\r//' %{buildroot}/%{_datadir}/%{name}/contrib/windows/*
#chmod -x %{buildroot}/%{_datadir}/%{name}/contrib/windows/*

# fix rpmlint E: script-without-shebang
#sed -i '1i#!/usr/bin/python' %{buildroot}%{_datadir}/%{name}/contrib/bk_buildbot.py


%files

%files master
%doc master/README.rst
%doc %{_mandir}/man1/buildbot.1.gz
%{_bindir}/buildbot
%{python_sitelib}/buildbot
%{python_sitelib}/buildbot-*egg-info
%{_datadir}/%{name}

%files slave
%doc slave/COPYING 
%{_bindir}/buildslave
%{python_sitelib}/buildslave
%{python_sitelib}/buildbot_slave-*egg-info

%files doc
%{_pkgdocdir}


%changelog
* Sat Aug 15 2015 Pete Travis <immanetize@fedoraproject.org> - 0.9.0b1-1
- Rework spec for buildbot nine
